Index: XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.cpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.cpp	(revision 657)
+++ XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.cpp	(revision 657)
@@ -0,0 +1,237 @@
+/*!
+   \file domain_algorithm_interpolate_from_file.cpp
+   \author Ha NGUYEN
+   \since 09 Jul 2015
+   \date 17 Jul 2015
+
+   \brief Algorithm for interpolation on a domain.
+ */
+#include "domain_algorithm_interpolate_from_file.hpp"
+#include <boost/unordered_map.hpp>
+#include "context.hpp"
+#include "context_client.hpp"
+#include "distribution_client.hpp"
+#include "client_server_mapping_distributed.hpp"
+
+namespace xios {
+
+CDomainAlgorithmInterpolateFromFile::CDomainAlgorithmInterpolateFromFile(CDomain* domainDestination, CDomain* domainSource, CInterpolateFromFileDomain* interpDomain)
+: CDomainAlgorithmTransformation(domainDestination, domainSource), interpDomain_(interpDomain)
+{
+  interpDomain_->checkValid(domainSource);
+  computeIndexSourceMapping();
+}
+
+/*!
+  Compute the index mapping between domain on grid source and one on grid destination
+*/
+void CDomainAlgorithmInterpolateFromFile::computeIndexSourceMapping()
+{
+  CContext* context = CContext::getCurrent();
+  CContextClient* client=context->client;
+  int clientRank = client->clientRank;
+
+  std::string filename = interpDomain_->file.getValue();
+  std::map<int,std::vector<std::pair<int,double> > > interpMapValue;
+//  readInterpolationInfo(filename, interpMapValue);
+
+  randomizeInterpolationInfo(interpMapValue);
+  boost::unordered_map<size_t,int> globalIndexOfDomainDest;
+  int ni = domainDest_->ni.getValue();
+  int nj = domainDest_->nj.getValue();
+  int ni_glo = domainDest_->ni_glo.getValue();
+  size_t globalIndex;
+  int nIndexSize = domainDest_->i_index.numElements(), i_ind, j_ind;
+  for (int idx = 0; idx < nIndexSize; ++idx)
+  {
+    i_ind=domainDest_->i_index(idx) ;
+    j_ind=domainDest_->j_index(idx) ;
+
+    globalIndex = i_ind + j_ind * ni_glo;
+    globalIndexOfDomainDest[globalIndex] = clientRank;
+  }
+
+  CClientServerMappingDistributed domainIndexClientClientMapping(globalIndexOfDomainDest,
+                                                                 client->intraComm,
+                                                                 true);
+  CArray<size_t,1> globalIndexInterp(interpMapValue.size());
+  std::map<int,std::vector<std::pair<int,double> > >::const_iterator itb = interpMapValue.begin(), it,
+                                                                     ite = interpMapValue.end();
+  size_t globalIndexCount = 0;
+  for (it = itb; it != ite; ++it)
+  {
+    globalIndexInterp(globalIndexCount) = it->first;
+    ++globalIndexCount;
+  }
+
+  domainIndexClientClientMapping.computeServerIndexMapping(globalIndexInterp);
+  const std::map<int, std::vector<size_t> >& globalIndexInterpSendToClient = domainIndexClientClientMapping.getGlobalIndexOnServer();
+
+  //Inform each client number of index they will receive
+  int nbClient = client->clientSize;
+  int* sendBuff = new int[nbClient];
+  int* recvBuff = new int[nbClient];
+  for (int i = 0; i < nbClient; ++i) sendBuff[i] = 0;
+  int sendBuffSize = 0;
+  std::map<int, std::vector<size_t> >::const_iterator itbMap = globalIndexInterpSendToClient.begin(), itMap,
+                                                      iteMap = globalIndexInterpSendToClient.end();
+  for (itMap = itbMap; itMap != iteMap; ++itMap)
+  {
+    int sizeIndex = 0, mapSize = (itMap->second).size();
+    for (int idx = 0; idx < mapSize; ++idx)
+    {
+      sizeIndex += interpMapValue[(itMap->second)[idx]].size();
+    }
+    sendBuff[itMap->first] = sizeIndex;
+    sendBuffSize += sizeIndex;
+  }
+
+  MPI_Allreduce(sendBuff, recvBuff, nbClient, MPI_INT, MPI_SUM, client->intraComm);
+
+  int* sendIndexDestBuff = new int [sendBuffSize];
+  int* sendIndexSrcBuff  = new int [sendBuffSize];
+  double* sendWeightBuff = new double [sendBuffSize];
+
+  std::vector<MPI_Request> sendRequest;
+  // Now send index and weight
+  int sendOffSet = 0;
+  for (itMap = itbMap; itMap != iteMap; ++itMap)
+  {
+    int k = 0;
+    int mapSize = (itMap->second).size();
+
+    for (int idx = 0; idx < mapSize; ++idx)
+    {
+      std::vector<std::pair<int,double> >& interpMap = interpMapValue[(itMap->second)[idx]];
+      for (int i = 0; i < interpMap.size(); ++i)
+      {
+        sendIndexDestBuff[k] = (itMap->second)[idx];
+        sendIndexSrcBuff[k]  = interpMap[i].first;
+        sendWeightBuff[k]    = interpMap[i].second;
+        ++k;
+      }
+    }
+
+    sendRequest.push_back(MPI_Request());
+    MPI_Isend(sendIndexDestBuff + sendOffSet,
+             k,
+             MPI_INT,
+             itMap->first,
+             7,
+             client->intraComm,
+             &sendRequest.back());
+    sendRequest.push_back(MPI_Request());
+    MPI_Isend(sendIndexSrcBuff + sendOffSet,
+             k,
+             MPI_INT,
+             itMap->first,
+             8,
+             client->intraComm,
+             &sendRequest.back());
+    sendRequest.push_back(MPI_Request());
+    MPI_Isend(sendWeightBuff + sendOffSet,
+             k,
+             MPI_DOUBLE,
+             itMap->first,
+             9,
+             client->intraComm,
+             &sendRequest.back());
+    sendOffSet += k;
+  }
+
+  int recvBuffSize = recvBuff[clientRank];
+  int* recvIndexDestBuff = new int [recvBuffSize];
+  int* recvIndexSrcBuff  = new int [recvBuffSize];
+  double* recvWeightBuff = new double [recvBuffSize];
+  int receivedSize = 0;
+  int clientSrcRank;
+  while (receivedSize < recvBuffSize)
+  {
+    MPI_Status recvStatus;
+    MPI_Recv((recvIndexDestBuff + receivedSize),
+             recvBuffSize,
+             MPI_INT,
+             MPI_ANY_SOURCE,
+             7,
+             client->intraComm,
+             &recvStatus);
+
+    int countBuff = 0;
+    MPI_Get_count(&recvStatus, MPI_INT, &countBuff);
+    clientSrcRank = recvStatus.MPI_SOURCE;
+
+    MPI_Recv((recvIndexSrcBuff + receivedSize),
+             recvBuffSize,
+             MPI_INT,
+             clientSrcRank,
+             8,
+             client->intraComm,
+             &recvStatus);
+
+    MPI_Recv((recvWeightBuff + receivedSize),
+             recvBuffSize,
+             MPI_DOUBLE,
+             clientSrcRank,
+             9,
+             client->intraComm,
+             &recvStatus);
+
+    for (int idx = 0; idx < countBuff; ++idx)
+    {
+      transformationMapping_[*(recvIndexDestBuff + receivedSize + idx)].push_back(*(recvIndexSrcBuff + receivedSize + idx));
+      transformationWeight_[*(recvIndexDestBuff + receivedSize + idx)].push_back(*(recvWeightBuff + receivedSize + idx));
+    }
+    receivedSize += countBuff;
+  }
+
+  std::vector<MPI_Status> requestStatus(sendRequest.size());
+  MPI_Wait(&sendRequest[0], &requestStatus[0]);
+
+  delete [] sendIndexDestBuff;
+  delete [] sendIndexSrcBuff;
+  delete [] sendWeightBuff;
+  delete [] recvIndexDestBuff;
+  delete [] recvIndexSrcBuff;
+  delete [] recvWeightBuff;
+  delete [] sendBuff;
+  delete [] recvBuff;
+}
+
+void CDomainAlgorithmInterpolateFromFile::randomizeInterpolationInfo(std::map<int,std::vector<std::pair<int,double> > >& interpMapValue)
+{
+  int iDestBegin = 2;
+  int jDestBegin = 2;
+
+  int ni_glo_src = domainSrc_->ni_glo.getValue();
+  int ni_glo = domainDest_->ni_glo.getValue();
+  size_t globalIndex;
+  int nIndexSize = domainDest_->i_index.numElements(), i_ind, j_ind;
+  for (int idx = 0; idx < nIndexSize; ++idx)
+  {
+    i_ind=domainDest_->i_index(idx) ;
+    j_ind=domainDest_->j_index(idx) ;
+
+    globalIndex = i_ind + j_ind * ni_glo;
+
+    interpMapValue[globalIndex].push_back(make_pair((i_ind+iDestBegin) + (j_ind+jDestBegin-1)*ni_glo_src, 0.25));
+    interpMapValue[globalIndex].push_back(make_pair((i_ind+iDestBegin+1) + (j_ind+jDestBegin)*ni_glo_src, 0.25));
+    interpMapValue[globalIndex].push_back(make_pair((i_ind+iDestBegin) + (j_ind+jDestBegin+1)*ni_glo_src, 0.25));
+    interpMapValue[globalIndex].push_back(make_pair((i_ind+iDestBegin-1) + (j_ind+jDestBegin)*ni_glo_src, 0.25));
+
+
+  }
+}
+
+/*!
+  Read interpolation information from a file
+  \param [in] filename interpolation file
+  \param [in/out] interpMapValue Mapping between (global) index of domain on grid destination and
+         corresponding global index of domain and associated weight value on grid source
+*/
+void CDomainAlgorithmInterpolateFromFile::readInterpolationInfo(std::string& filename,
+                                                                std::map<int,std::vector<std::pair<int,double> > >& interpMapValue)
+{
+
+}
+
+}
Index: XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.hpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.hpp	(revision 657)
+++ XIOS/trunk/src/transformation/domain_algorithm_interpolate_from_file.hpp	(revision 657)
@@ -0,0 +1,39 @@
+/*!
+   \file domain_algorithm_interpolate_from_file.hpp
+   \author Ha NGUYEN
+   \since 09 July 2015
+   \date 09 July 2015
+
+   \brief Algorithm for interpolation on a domain.
+ */
+#ifndef __XIOS_DOMAIN_ALGORITHM_INTERPOLATE_FROM_FILE_HPP__
+#define __XIOS_DOMAIN_ALGORITHM_INTERPOLATE_FROM_FILE_HPP__
+
+#include "domain_algorithm_transformation.hpp"
+#include "domain.hpp"
+#include "interpolate_from_file_domain.hpp"
+
+namespace xios {
+/*!
+  \class CDomainAlgorithmInterpolateFromFile
+  Reading interpolation from file then apply on a domain
+*/
+class CDomainAlgorithmInterpolateFromFile : public CDomainAlgorithmTransformation
+{
+public:
+  CDomainAlgorithmInterpolateFromFile(CDomain* domainDestination, CDomain* domainSource, CInterpolateFromFileDomain* interpDomain);
+
+  virtual ~CDomainAlgorithmInterpolateFromFile() {}
+
+  virtual void computeIndexSourceMapping();
+
+private:
+  void readInterpolationInfo(std::string& filename, std::map<int,std::vector<std::pair<int,double> > >& interpMapValue);
+  void randomizeInterpolationInfo(std::map<int,std::vector<std::pair<int,double> > >& interpMapValue);
+private:
+  CInterpolateFromFileDomain* interpDomain_;
+
+};
+
+}
+#endif // __XIOS_DOMAIN_ALGORITHM_INTERPOLATE_FROM_FILE_HPP__
Index: XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 656)
+++ XIOS/trunk/src/transformation/domain_algorithm_transformation.cpp	(revision 657)
@@ -172,5 +172,5 @@
         for (int k = 1; k < globalDim; ++k)
         {
-          mulDim *= gridDestGlobalDim[k-1];
+          mulDim *= gridSrcGlobalDim[k-1];
           globIndex += (currentIndex[k])*mulDim;
         }
Index: XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 656)
+++ XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 657)
@@ -52,5 +52,5 @@
                                                    globalIndexSrcGrid);
     size_t globalIndexSize = globalIndexDestGrid.numElements();
-    std::vector<double> currentVecWeight = itTransWeight->second;
+    const std::vector<double>& currentVecWeight = itTransWeight->second;
     for (size_t idx = 0; idx < globalIndexSize; ++idx)
     {
Index: XIOS/trunk/src/transformation/grid_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/grid_transformation.cpp	(revision 656)
+++ XIOS/trunk/src/transformation/grid_transformation.cpp	(revision 657)
@@ -12,4 +12,5 @@
 #include "axis_algorithm_interpolate.hpp"
 #include "domain_algorithm_zoom.hpp"
+#include "domain_algorithm_interpolate_from_file.hpp"
 #include "context.hpp"
 #include "context_client.hpp"
@@ -277,7 +278,12 @@
 
   CZoomDomain* zoomDomain = 0;
+  CInterpolateFromFileDomain* interpFileDomain = 0;
   CGenericAlgorithmTransformation* algo = 0;
   switch (transType)
   {
+    case TRANS_INTERPOLATE_DOMAIN_FROM_FILE:
+      interpFileDomain = dynamic_cast<CInterpolateFromFileDomain*> (it->second);
+      algo = new CDomainAlgorithmInterpolateFromFile(domainListDestP[domainIndex], domainListSrcP[domainIndex],interpFileDomain);
+      break;
     case TRANS_ZOOM_DOMAIN:
       zoomDomain = dynamic_cast<CZoomDomain*> (it->second);
@@ -308,4 +314,5 @@
   switch (transType)
   {
+    case TRANS_INTERPOLATE_DOMAIN_FROM_FILE:
     case TRANS_ZOOM_DOMAIN:
       domainIndex = elementPosition2DomainPositionInGrid_[elementPositionInGrid];
Index: XIOS/trunk/src/type/type_util.hpp
===================================================================
--- XIOS/trunk/src/type/type_util.hpp	(revision 656)
+++ XIOS/trunk/src/type/type_util.hpp	(revision 657)
@@ -28,4 +28,5 @@
     class CZoomDomain;
     class CZoomDomainGroup;
+    class CInterpolateFromFileDomainGroup;
 
   template <typename T> inline string getStrType(void);
@@ -72,4 +73,6 @@
   macro(CZoomDomain)
   macro(CZoomDomainGroup)
+  macro(CInterpolateFromFileDomain)
+  macro(CInterpolateFromFileDomainGroup)
 #undef macro
 }
Index: XIOS/trunk/src/xml_parser_decl.cpp
===================================================================
--- XIOS/trunk/src/xml_parser_decl.cpp	(revision 656)
+++ XIOS/trunk/src/xml_parser_decl.cpp	(revision 657)
@@ -1,14 +1,5 @@
 #include "xml_parser_impl.hpp"
 #include "group_template.hpp"
-#include "context.hpp"
-#include "axis.hpp"
-#include "domain.hpp"
-#include "field.hpp"
-#include "file.hpp"
-#include "variable.hpp"
-#include "inverse_axis.hpp"
-#include "zoom_axis.hpp"
-#include "interpolate_axis.hpp"
-#include "zoom_domain.hpp"
+#include "node_type.hpp"
 
 namespace xios
@@ -32,4 +23,5 @@
     macro( InterpolateAxis )
     macro( ZoomDomain )
+    macro( InterpolateFromFileDomain )
   }
 }
